package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.ExpendType;
import com.ff.weijinxiao.repository.ExpendTypeRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class ExpendTypeService {

    @Resource
    private ExpendTypeRepository expendTypeRepository;

    /**
     * 创建实体
     *
     * @param expendType
     */
    public ExpendType saveExpendType(ExpendType expendType) {
        return expendTypeRepository.save(expendType);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public ExpendType findById(Integer id) {
        Optional<ExpendType> optional = expendTypeRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        expendTypeRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<ExpendType> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return expendTypeRepository.findAll(SpecificationUtil.buildSpecification(param, ExpendType.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<ExpendType> findList(Map<String, Object> param) {
        return expendTypeRepository.findAll(SpecificationUtil.buildSpecification(param, ExpendType.class));
    }

}
